goog.provide('Blockly.Python.nplus');
goog.require('Blockly.Python');


// 颜色传感器值 返回列表
Blockly.Python['mpython_lark_get_all_color'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_color'] = 'color = Color()\ncolor.setup()\ncolor.turn_on()';
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'color.getRGB()';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 颜色传感器值 返回RGB单色值
Blockly.Python['mpython_lark_get_color'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_color'] = 'color = Color()\ncolor.setup()\ncolor.turn_on()';
    var lark_r_g_b = block.getFieldValue('lark_r_g_b');
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'color.getRGB()[' + lark_r_g_b + ']';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 颜色传感器值 _hsv  
Blockly.Python['mpython_lark_get_all_color_hsv'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_color'] = 'color = Color()\ncolor.setup()\ncolor.turn_on()';
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'color.getHSV()';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 颜色传感器值 _hsv  单值
Blockly.Python['mpython_lark_get_color_hsv'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_color'] = 'color = Color()\ncolor.setup()\ncolor.turn_on()';
    var lark_hsv = block.getFieldValue('lark_hsv');
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'color.getHSV()[' + lark_hsv + ']';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 颜色传感器值
Blockly.Python['mpython_lark_discern_color'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_color'] = 'color = Color()\ncolor.setup()\ncolor.turn_on()';
    var rainbow = block.getFieldValue('rainbow');
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    switch (rainbow){
        case 'red':
            var code_rainbow = 'red()';
            break;
        case 'green':
            code_rainbow = 'green()';
            break;
        case 'blue':
            code_rainbow = 'blue()';
            break;  
        case 'orange':
            code_rainbow = 'orange()';
            break;
        case 'yellow':
            code_rainbow = 'yellow()';
            break;
        case 'purple':
            code_rainbow = 'purple()';
            break;
        case 'cyan':
            code_rainbow = 'cyan()';
            break;      
    }
    //var code = '\'' + rainbow + '\'';
    var code = 'color.discern_' + code_rainbow;
    return [code, Blockly.Python.ORDER_ATOMIC];
};

//超声波
Blockly.Python['mpython_lark_ultrasonic'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_Ultrasonic'] = 'ultrasonic = Ultrasonic()';
    var code = 'ultrasonic.distance()';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 直流电机驱动
Blockly.Python['mpython_lark_motor_set_i2c'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_motor'] = 'motor = Motor()';
    var lark_left_right_interface = block.getFieldValue('lark_left_right_interface');
    var speed = Blockly.Python.valueToCode(block, 'speed', Blockly.Python.ORDER_ATOMIC);
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'motor.' + lark_left_right_interface + '(' + speed + ')\n';
    //return [code, Blockly.Python.ORDER_ATOMIC];
	return code;
};

// 循迹传感器 返回线数值
Blockly.Python['mpython_lark_line_number_on_i2c'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_line'] = 'line=Line()';
    var left_right_interface = block.getFieldValue('left_right_interface');
    //var speed = Blockly.Python.valueToCode(block, 'speed', Blockly.Python.ORDER_ATOMIC);
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'line.' + left_right_interface +'()' ;
    return [code, Blockly.Python.ORDER_ATOMIC];
};

//循迹传感器 探测线
Blockly.Python['mpython_lark_line_search'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_line'] = 'line=Line()';
    var lark_search_line = block.getFieldValue('lark_search_line');
    //var speed = Blockly.Python.valueToCode(block, 'speed', Blockly.Python.ORDER_ATOMIC);
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'line.' + lark_search_line +'()' ;
    return [code, Blockly.Python.ORDER_ATOMIC];
};

//---------------------------千里马-----------------------------//
//----------------------------------------------------------------//
///----------------------------------------------------------------//
////----------------------------------------------------------------//
///----------------------------------------------------------------//
///----------------------------------------------------------------//
///----------------------------------------------------------------//
///----------------------------------------------------------------//
///----------------------------------------------------------------//
///----------------------------------------------------------------//
///----------------------------------------------------------------//
///----------------------------------------------------------------//
///----------------------------------------------------------------//
//----------------------------------------------------------------//
//----------------------------------------------------------------///
//----------------------------------------------------------------///
//----------------------------------------------------------------////
//----------------------------------------------------------------///
//----------------------------------------------------------------//
//----------------------------------------------------------------//
//----------------------------------------------------------------//

// 颜色传感器值 返回列表
Blockly.Python['mpython_lark_car_get_all_color'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_color'] = 'car = Car()\ncar.colorsenser()';
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'car.getRGB()';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 颜色传感器值 返回RGB单色值
Blockly.Python['mpython_lark_car_get_color'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_color'] = 'car = Car()\ncar.colorsenser()';
    var lark_r_g_b = block.getFieldValue('car_r_g_b');
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'car.getRGB()[' + lark_r_g_b + ']';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 颜色传感器值 _hsv  
Blockly.Python['mpython_lark_car_get_all_color_hsv'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_color'] = 'car = Car()\ncar.colorsenser()';
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'car.getHSV()';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 颜色传感器值 _hsv  单值
Blockly.Python['mpython_lark_car_get_color_hsv'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_color'] = 'car = Car()\ncar.colorsenser()';
    var car_hsv = block.getFieldValue('car_hsv');
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'car.getHSV()[' + car_hsv + ']';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 颜色传感器值 获取string类型     删除
Blockly.Python['mpython_lark_car_get_color_string'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_color'] = 'car = Car()\ncar.colorsenser()';
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'car.discern()';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 颜色传感器值
Blockly.Python['mpython_lark_car_discern_color'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_color'] = 'car = Car()\ncar.colorsenser()';
    var car_rainbow = block.getFieldValue('car_rainbow');
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    switch (car_rainbow){
        case 'red':
            var code_rainbow = 'red()';
            break;
        case 'green':
            code_rainbow = 'green()';
            break;
        case 'blue':
            code_rainbow = 'blue()';
            break;  
        case 'orange':
            code_rainbow = 'orange()';
            break;
        case 'yellow':
            code_rainbow = 'yellow()';
            break;
        case 'purple':
            code_rainbow = 'purple()';
            break;
        case 'cyan':
            code_rainbow = 'cyan()';
            break;      
    }
    var code = 'car.discern_' + code_rainbow;
    return [code, Blockly.Python.ORDER_ATOMIC];
};

//超声波
Blockly.Python['mpython_lark_car_ultrasonic'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_Ultrasonic'] = 'car = Car()';
    var code = 'car.distance()';
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 循迹传感器 返回线数值
Blockly.Python['mpython_lark_car_line_number_on_i2c'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_line'] = 'car = Car()';
    var car_left_right_interface = block.getFieldValue('car_left_right_interface');
    //var speed = Blockly.Python.valueToCode(block, 'speed', Blockly.Python.ORDER_ATOMIC);
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'car.' + car_left_right_interface +'()' ;
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 循迹传感器 探测
Blockly.Python['mpython_lark_car_line_search'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_line'] = 'car = Car()';
    var lark_car_search_line = block.getFieldValue('lark_car_search_line');
    //var speed = Blockly.Python.valueToCode(block, 'speed', Blockly.Python.ORDER_ATOMIC);
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    var code = 'car.' + lark_car_search_line +'()' ;
    return [code, Blockly.Python.ORDER_ATOMIC];
};

// 千里马走向
Blockly.Python['mpython_lark_car_motor_set_i2c'] = function (block) {
    Blockly.Python.definitions_['import_mpython'] = 'from mpython import *';
    Blockly.Python.definitions_['import_lark'] = 'from lark import *';
    Blockly.Python.functions_['init_car_motion'] = 'car=Car()';
    var lark_car_motion = block.getFieldValue('lark_car_motion');
    var speed = Blockly.Python.valueToCode(block, 'speed', Blockly.Python.ORDER_ATOMIC);
    //var speed = Blockly.Python.valueToCode(block, 'speed', Blockly.Python.ORDER_ATOMIC);
    // var seg_num = Blockly.Python.valueToCode(block, 'seg_num', Blockly.Python.ORDER_ATOMIC);
    if (lark_car_motion == 'stop'){
        var code = 'car.' + lark_car_motion +'()' ;
    }
    else{
        var code = 'car.' + lark_car_motion +'('+speed+')' ;
    }   
    //return [code, Blockly.Python.ORDER_ATOMIC];
    return code;
};
